#uses "fwUnitTestComponentAsserts.ctl"

#uses "unFrontEnd/AutoResetModbusError.ctl"

//-------------------------------------------------------
void test_AutoResetModbusError_testPlcNotConnected() {
	int iRes = _unSystemIntegrity_autoResetModbusError( "N/A", "N/A", 0, 1);
	assertEqual( 1, iRes, "_unSystemIntegrity_autoResetModbusError seems to not discard when the PLC is not connected");
}

//-------------------------------------------------------
void test_AutoResetModbusError_testPlcConnectedNoError() {
	int iRes = _unSystemIntegrity_autoResetModbusError( "N/A", "N/A", 1, 0);
	assertEqual( 1, iRes, "_unSystemIntegrity_autoResetModbusError seems to not discard when the PLC is connected and no error is present");
}

//-------------------------------------------------------
void test_AutoResetModbusError_testPlcGqNoError() {
	int iRes = _unSystemIntegrity_autoResetModbusError( "N/A", "N/A", 2, 0);
	assertEqual( 1, iRes, "_unSystemIntegrity_autoResetModbusError seems to not discard when the PLC is doing a general query and no error is present");
}

//-------------------------------------------------------
void test_AutoResetModbusError_testPlcConnectedWithError() {
	int iRes = _unSystemIntegrity_autoResetModbusError( "N/A", "N/A", 1, 2);
	assertEqual( -1, iRes, "_unSystemIntegrity_autoResetModbusError does not return an error when trying to reset a non existing PLC.");
}

//-------------------------------------------------------
/* The goal here is to test that calling _unSystemIntegrity_isTooManyAutoResetError
	more than 3 times in less 10 seconds returns true.
*/
void test_AutoResetModbusError_isTooManyAutoResetError(){
	bool bRes = _unSystemIntegrity_isTooManyAutoResetError("MyPlc");
	assertEqual( false, bRes, "_unSystemIntegrity_isTooManyAutoResetError returns true when called just once");

	bool bRes2;
	for( int i=1; i<=3; i++){
		bRes2 = _unSystemIntegrity_isTooManyAutoResetError("MyPlc");
		delay(0,500);
	}
	//the last call should have returned true, i.e. too many calls in a short period
	assertEqual(bRes2, true, "_unSystemIntegrity_isTooManyAutoResetError does not detect that it is called more than 3 times in less than 10 seconds");

	//wait for a bit more than 10 seconds and check that it returns false again
	delay(12);
	bRes = _unSystemIntegrity_isTooManyAutoResetError("MyPlc");
	assertEqual( false, bRes, "_unSystemIntegrity_isTooManyAutoResetError does not recover after the 10 seconds delay.");
}




