#uses "fwUnitTestComponentAsserts.ctl"

#uses "test/unFrontEnd/unFrontEndTest_helper.ctl"

#uses "unFrontEnd/DeleteSubApplication.ctl"

#uses "unConfigGenericFunctions.ctl"

const string DEVICES_DRIVER_NUMBER = "3";

//this is the name of FrontEnd imported by setupSuite()
const string FRONTENDDPTEST = "_unPlc_PLCENICE03.configuration.type:_original_value"; //gives a DPE instead of a DP on purpose to check that the name is properly parsed


//-------------------------------------------------------
void test_unFrontEnd_deleteSubApplication_setupSuite() {
	unImportTestDevice_helper_startDriver(DEVICES_DRIVER_NUMBER);
	fwDevice_initialize(); //needed by unImportDevice_checkFile()... dont ask me why

	//Then import 2 applications omn the same frontend
	string sLogContent;
	string sImportFile1 = "test_unFrontEnd/wincc_oa_db_file_Schneider_PLCENICE03_M580.txt";
   bool importOk = unImportTestDevice_helper_importDevices(sImportFile1, DEVICES_DRIVER_NUMBER, sLogContent);
	assertEqual( true, importOk, "Unable to import front end "+sImportFile1+" "+sLogContent);

	string sImportFile2 = "test_unFrontEnd/wincc_oa_db_file_Schneider_PLCENICE03_2_M580.txt";
   importOk = unImportTestDevice_helper_importDevices(sImportFile2, DEVICES_DRIVER_NUMBER, sLogContent);
	assertEqual( true, importOk, "Unable to import front end "+sImportFile2+" "+sLogContent);
}

//-------------------------------------------------------
void test_unFrontEnd_deleteSubApplication_teardownSuite() {
	dyn_string dsDp=dpNames("*PLCENICE03*");
	dynAppend( dsDp, dpNames("_Mod_Plc_3"));
	for(int i=1; i<=dynlen(dsDp);i++)	dpDelete(dsDp[i]);
}


//-------------------------------------------------------
void test_deleteSubApplication_testGetApplicationAndDevicesNumber() {
  vector<SubApplicationDevices> vSad = unFrontEnd_DeleteSubApp_getAppAndNumDevices(FRONTENDDPTEST);
	
	assertEqual(2, vSad.count(), "Incorrect number of applications found");
	
	for(int i=0; i<vSad.count(); i++){
		assertEqual(4, vSad[i].getNumDevices(), "Incorrect number of devices found for application "+vSad[i].getApplicationName());
	}
}


//--------------------------------------------------------------
//void test_deleteSubApplication_testGetFrontEndApplications()
//{
// Not needed it is implicitly tested via  test_deleteSubApplication_testGetApplicationAndDevicesNumber
//}

//--------------------------------------------------------------
void test_deleteSubApplication_test_removeNonExistingFrontEnd(){
	int iRes = unFrontEnd_DeleteSubApp_remove("NotExistingFrontEnd", "N/A");
	assertEqual(-1, iRes, "Trying to remove an non existing frontEnd did not return the expected error code");
}

//--------------------------------------------------------------
void test_deleteSubApplication_test_removeNonExistingApp(){
	int iRes = unFrontEnd_DeleteSubApp_remove(FRONTENDDPTEST, "N/A");
	assertEqual(1, iRes, "Trying to remove an non existing application did not return the expected return code");
}

//--------------------------------------------------------------
void test_deleteSubApplication_test_removeNonEmptyApp(){
	int iRes = unFrontEnd_DeleteSubApp_remove(FRONTENDDPTEST, "ConstInpTestDelete");
	assertEqual(-3, iRes, "Trying to remove an non empty application did not return the expected return code");
	vector<SubApplicationDevices> vSad = unFrontEnd_DeleteSubApp_getAppAndNumDevices(FRONTENDDPTEST);
	assertEqual(2, vSad.count(), "Incorrect number of applications found after trying to  delete an non empty app");
}

//--------------------------------------------------------------
void test_deleteSubApplication_test_removeEmptyApp(){
	dyn_string dsDp=dpNames("*-ConstInpTestDelete-*");
	for(int i=1; i<=dynlen(dsDp);i++)	dpDelete(dsDp[i]);
	
	int iRes = unFrontEnd_DeleteSubApp_remove(FRONTENDDPTEST, "ConstInpTestDelete");
	assertEqual(1, iRes, "Trying to remove an existing application did not return the expected return code");
	
	vector<SubApplicationDevices> vSad = unFrontEnd_DeleteSubApp_getAppAndNumDevices(FRONTENDDPTEST);
	assertEqual(1, vSad.count(), "Incorrect number of applications found after  deleting an empty app");
}



