//-------------------------------------------------------
public bool unImportTestDevice_helper_importDevices(string sFileName, int iDriver, string &sLogContent) {
  dyn_string exceptionInfo;
  string logfile = tmpnam();

  sFileName = getPath(DATA_REL_PATH, sFileName); 

  if (dynlen(exceptionInfo) > 0) {
      DebugTN(exceptionInfo);
      exit(1);
  }

  bool importOk = unImportDevice_importFile(sFileName, 
                                logfile,
                                iDriver, 
                                "RDB-99) EVENT",
                                "RDB-99) EVENT",
                                "RDB-99) EVENT",
                                false);

  bool bReadLog = fileToString(logfile, sLogContent);
  
  remove(logfile);

  return importOk & bReadLog;
}

//-------------------------------------------------------
public bool unImportTestDevice_helper_checkDevices(string sFileName, string sFrontEndType, int iDriver, string &sLogContent) {
  dyn_string exceptionInfo;
  string logfile = tmpnam();
  bool deleteRequested;

  sFileName = getPath(DATA_REL_PATH, sFileName);

  assertEqual(true, sFileName!="", "Unable to find the import file "+ sFileName);
 
  if (dynlen(exceptionInfo) > 0) {
      DebugTN(exceptionInfo);
      exit(1);
  }
 

  bool importOk = unImportDevice_checkFile(sFileName, 
                                logfile,
                                sFrontEndType,
                                iDriver, 
                                "RDB-99) EVENT",
                                "RDB-99) EVENT",
                                "RDB-99) EVENT",
                                deleteRequested);

  bool bReadLog = fileToString(logfile, sLogContent);
  
  remove(logfile);

  return bReadLog;
}

//-------------------------------------------------------
public void unImportTestDevice_helper_startDriver(int iDriver){
  if (fwInstallationManager_isDriverRunning(iDriver)){
    return;
  }

  fwInstallationManager_add("WCCILsim", "always", 30, 2, 30, "-num "+iDriver);

  fwInstallationManager_waitForState( true, iDriver);
}


//-------------------------------------------------------
public void unImportTestDevice_helper_checkImportSuccessful( string sImportFile, string sLogContent){
  bool bIsWarningPresent = strpos(sLogContent, "WARNING") >= 0;
  bool bIsErrorPresent = strpos(sLogContent, "ERROR") >= 0;
  bool bIsImportSuccess = strpos(sLogContent, "file was successfully imported") >= 0;

  assertEqual( false, bIsWarningPresent, "There was a warning when importing " + sImportFile + "\n"+sLogContent);
  assertEqual( false, bIsErrorPresent, "There was an error when importing " + sImportFile + "\n"+sLogContent);
  assertEqual( true, bIsImportSuccess, "Import did not complete (log does not contains successful importation statement) "+sImportFile + "\n"+sLogContent);
}
